/***
 * OW2 FraSCAti Tinfi
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org
 *
 * Authors: Lionel Seinturier, Philippe Merle
 */

package org.ow2.frascati.tinfi.control.content.scope;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.NameController;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.osoa.sca.ComponentContext;
import org.ow2.frascati.tinfi.control.content.ContentClassMetaData;
import org.ow2.frascati.tinfi.control.property.SCAPropertyController;

/**
 * Manager for composite-scoped components.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @author Philippe Merle <Philippe.Merle@lifl.fr>
 */
public class CompositeScopeManager extends AbstractScopeManager implements ScopeManager {

    public CompositeScopeManager(
        Component comp, SCAPropertyController scapc, ComponentContext compCtx,
        NameController nc, ContentClassMetaData ccmd ) {
    
        super(comp,scapc,compCtx,nc,ccmd);
    }
    
    public Object getFcContent() throws InstantiationException {
        synchronized(this) {
            if( contentCompositeScope == null ) {
                contentCompositeScope = createAndInitializeFcInstance();
            }
        }
        return contentCompositeScope;
    }
    
    public void releaseFcContent( Object content, boolean isEndMethod ) {
        destroyFcInstance(content);
    }
    
    /** The content instance for composite scoped components. */
    private Object contentCompositeScope;
}
